//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  JScript project collection_long.jsp                                                             *****
//*****                                                                                                  *****
//*****  ACTION                                                                                          *****
//*****                                                                                                  *****
//*****  Version 3.0 / March, 2009                                                                       *****
//*****                                                                                                  *****
//*****  Author V.I. Tsanev (vip20@cam.ac.uk)                                                            *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****

        Specbar.CloseAllSpectra()                  ;

//*****                                                                                                  *****
//***** Crate base holder - if folder exists terminate the script ********************************************
//*****                                                                                                  *****

        name1 = name ; name2 = name ; BasePath = name ;
        fldr = "c:\\work\\ooi\\" + BasePath + "\\"                  ;
        ReportFolderStatus(fldr)                                      ;
		if (fldrEXISTS == 1) 
		     { 
		       Console.WriteLine("KEY = " + fldrEXISTS +" folder " + fldr + " exists")        ;
		       Console.WriteLine("")                                                          ;
		       Console.WriteLine("Script terminated!")                                        ; 
		       Process.Start("C:\\work\\beep.exe")                                            ;   
		     }
		else 
		     { // folder BasePath created - start 
			   Console.WriteLine("KEY = " + fldrEXISTS +" folder " + fldr + " just created ") ; 
			   WORKfolder = fso.CreateFolder(fldr);

//*****                                                                                                  *****
//***** Initialize spectrometer's related variables depending ob spectrometer'e type *************************
//*****                                                                                                  *****

		if ( spectrometerTYPE == "USB4000" )
		           { // USB4000 spectrometer
					 uiwWriter.Status = "USB4000 detected"; uiwWriter.Status = "" ; 
                     NumberPixels = 3648 ; MaxADCcount = 65535 ; spectro = 1 ; 
		             MinChannelToShow =0 ; MaxChannelToShow = 3647 ; }
        else if ( spectrometerTYPE == "USB2000" )  
		          { // USB2000 spectrometer
					 uiwWriter.Status = "USB2000 detected"; uiwWriter.Status = "" ;
                     NumberPixels = 2048 ; MaxADCcount = 4095 ; spectro = 1 ; 
		             MinChannelToShow =0 ; MaxChannelToShow = 2047 ; }
        else if ( spectrometerTYPE == "USB2000+" )  
		          { // USB2000+ spectrometer
					 uiwWriter.Status = "USB2000+ detected"; uiwWriter.Status = "" ;
                     NumberPixels = 2048 ; MaxADCcount = 65535 ; spectro = 1 ; 
		             MinChannelToShow =0 ; MaxChannelToShow = 2047 ; }
		 else
		          { // wrong spectrometer type           
					 uiwWriter.Status = "Wrong spectrometer type!"; uiwWriter.Status = "" ;
                     spectro = 0 ; }
        HighControlLevel = MaxADCcount * coeffHIGH ; LowControlLevel  = MaxADCcount * coeffLOW  ;
        MaxSignal        = MaxADCcount * coeffUP   ; MinSignal  = MaxADCcount * coeffDOWN       ;
		//Console.WriteLine(MinSignal+"\t"+MaxSignal) ;

//*****                                                                                                  *****
//***** Create the low spectrum object ***********************************************************************
//*****                                                                                                  *****

        LowSpec = Specbar.GetSpectrum("Low Spectrum")                                 ;
        LowSpec.NChannel = NumberPixels ;
        LowSpec.MinChannel = MinChannelToShow ; LowSpec.MaxChannel = MaxChannelToShow ;
        LowSpec.MathLow    = MinChannelToShow ; LowSpec.MathHigh   = MaxChannelToShow ;

//*****                                                                                                  *****
//***** Create the high spectrum object **********************************************************************
//*****                                                                                                  *****

        HighSpec = Specbar.GetSpectrum("High Spectrum")                                 ;
		HighSpec.NChannel = NumberPixels ;
        HighSpec.MinChannel = MinChannelToShow ; HighSpec.MaxChannel = MaxChannelToShow ;
        HighSpec.MathLow    = MinChannelToShow ;   HighSpec.MathHigh = MaxChannelToShow ;

//*****                                                                                                  *****
//***** Cteate MeasSpec spectrum object **********************************************************************
//*****                                                                                                  *****

        MeasSpec = Specbar.GetSpectrum("Measurement Spectrum")                                ;
		MeasSpec.NChannel  = NumberPixels ;
        MeasSpec.MinChannel = MinChannelToShow ; MeasSpec.MaxChannel = MaxChannelToShow       ;
        MeasSpec.MathLow    = MinChannelToShow ; MeasSpec.MathHigh   = MaxChannelToShow       ;

//*****                                                                                                  *****
//***** Get the date *****************************************************************************************
//*****                                                                                                  *****

        datata = Datum() ; uiwWriter.Status = ""   ; 	                   ;

//*****                                                                                                  *****
//***** Create common protocol outfile (ioRes) and write header **********************************************
//***** Default file name is c:\work\ooi\BasePath\protocol_name1.csv                                     *****
//*****                                                                                                  *****

        Console.WriteLine("c:\\work\\ooi\\"+BasePath+"\\protocol_"+name1+".csv")               ;
		ioRes = fso.CreateTextFile("c:\\work\\ooi\\"+BasePath+"\\protocol_"+name1+".csv",true) ;
		TempName = "c:\\work\\ooi\\" + BasePath+ "\\" + TempName+ ".txt" ;
		ioList = fso.CreateTextFile(TempName , true)    ;

//*****                                                                                                  *****

        ioRes.WriteLine( "Experiment"   + "," +              experimentID + "" )               ;
	    ioRes.WriteLine( "Location"     + "," +                locationID + "" )               ;
	    ioRes.WriteLine( "Date"         + "," +                    datata + "" )               ;
        ioRes.WriteLine( "Spectrometer" + "," +                    specID + "" )               ;
	    ioRes.WriteLine( "Data folder"  + "," + "c:\\work\\ooi\\" + BasePath + "\\" )               ;
	    ioRes.WriteLine( "Author"       + "," +                  AuthorID + "" )               ;
	    ioRes.WriteLine( "")                                                                   ;
        ioRes.WriteLine("Data_Set_No,Start_time,IT,N_acc,End_time,No_spectra")                 ;

//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****

        j=-1 ;         // this variable counts sets of spectra (0, 1, 2,... )                            *****
		iGLOBAL = -1 ; // this variable counts all recorded spactra for the list file                    *****

//*****                                                                                                  *****

        if ( spectro == 1 )
           {
		     while(!Script.StopAllScripts) // loop until stop button is used

//*****                                                                                                  *****
//************************************************************************************************************
//***********                                                                                            *****

             {
		      j++ ; m=j ; k = Count(m) ; 
			  protocol = "optimization_" + name2 + k +"" ; name3 = name2 + k +"" ;    

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

    	      Process.Start("C:\\work\\beep.exe") ; Console.WriteLine("") ;
			  Console.WriteLine("Starting optimization for set #" + j + "") ; Console.WriteLine("") ;
              optimumIT() ;
			  if ( maxIT < ExpTime )
			     { maxIT = ExpTime ; maxNAC = NumbScans ; }
              Console.WriteLine("") ; Console.WriteLine("ExpTime =" + ExpTime + " ms") ; 
              Console.WriteLine("NumberScans =" + NumbScans + "") ;

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

              LowSignal = LowControlLevel * NumbScans ; HighSignal =  HighControlLevel * NumbScans ;
              startTIME = Tempo() ; label1 = parseInt(LowSignal) ;  label3 = parseInt(HighSignal) ;

//***********                                                                                            *****
//*********** Initaiate low spectrum value *******************************************************************
//***********                                                                                            *****

              SpecMath.MulScalar(LowSpec,0) ; SpecMath.AddScalar(LowSpec,LowSignal)         ;
              Console.WriteLine("LowSignal = " + parseInt(LowSignal) + "")                  ;

//***********                                                                                            *****
//*********** Initiate high spectrum value *******************************************************************
//***********                                                                                            *****

              SpecMath.MulScalar(HighSpec,0) ; SpecMath.AddScalar(HighSpec,HighSignal)        ;
              Console.WriteLine("HighSignal = " + parseInt(HighSignal) + "")                  ;
              Console.WriteLine("")                                                           ;

//**********                                                                                             *****
//************************************************************************************************************
//**********                                                                                             *****

              afnFile = new AutoFileName()                 ;
              afnFile.BasePath = "c:\\work\\ooi\\"+BasePath+"\\"                  ;
              afnFile.Prefix = name3 + "_"                 ;
              afnFile.Suffix = commonExtension             ;
              afnFile.FilesPerFolder = NumberPerFolder     ;
              afnFile.NumberOfDigits = 5                   ;

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

              iLOW  = 0 ; iHIGH = 0                        ;

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

              ioCur = fso.CreateTextFile("c:\\work\\ooi\\"+BasePath+"\\dataset_"+name3+".csv",true);
              ioCur.WriteLine("No,Spectrum,Time,Min_level,Spe_max,Max_level,Quality,ET,NAC") ;
              for ( III=1 ; III<=9 ; III++ )
                    { ioCur.WriteLine(",,,,,") ; }

//***********                                                                                            *****
//*********** Define some MeasSpec's atributes ***************************************************************
//***********                                                                                            *****

              LowSpec.ChartYAxis = "Fixed" ;
			  LowSpec.ChartYAxisMin = 0 ; LowSpec.ChartYAxisMax = parseInt(MaxADCcount*NumbScans) ;

//***********                                                                                            *****

              HighSpec.ChartYAxis = "Fixed" ;
			  HighSpec.ChartYAxisMin = 0 ; HighSpec.ChartYAxisMax = parseInt(MaxADCcount*NumbScans) ;

//***********                                                                                            *****

              MeasSpec.ChartYAxis = "Fixed" ;
			  MeasSpec.ChartYAxisMin = 0 ; MeasSpec.ChartYAxisMax = parseInt(MaxADCcount*NumbScans) ;
              Specbar.CurrentSpectrum = MeasSpec ; MeasSpec.OverlayMode = OverlayMode.Normal        ;
              MeasSpec.AddOverlay(HighSpec) ; MeasSpec.AddOverlay(LowSpec)                          ;

//***********                                                                                            *****

              spectrograph.Scan(MeasSpec,NumbScans,ExpTime)             ;
              MeasSpec.MinChannel = MinChannelToShow ; MeasSpec.MaxChannel = MaxChannelToShow       ;
              MeasSpec.Author = AuthorID ; MeasSpec.Device = specID                                 ;
              MeasSpec.UserParam1 = project                                                         ;
			  MeasSpec.UserParam2 = version                                                         ;
			  MeasSpec.UserParam3 = vip20                                                           ;
              Specbar.CurrentSpectrum = MeasSpec ; afnFile.Save(MeasSpec)                           ;
		      ii = afnFile.CurrentFileNumber() ; m=ii -1 ; k = Count(m)                             ;
		      label2 = parseInt(MeasSpec.Max)                                                       ;
			  Quality() ;

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

              time = MeasSpec.StopTime ; maxi   = parseInt(MeasSpec.Max+0.5) ;
              spec = "" + name3 + "_" + k + commonExtension + ""            ;
  			  iGLOBAL++ ; ioList.WriteLine(""+iGLOBAL+" "+afnFile.BasePath+afnFile.CurrentSubFolder+spec+"");
              ioCur.WriteLine( ""+(ii-1)+","+spec+","+time+","+LowSignal+","+ maxi+","+
		                       HighSignal+","+SpectrumQuality+","+ExpTime+","+NumbScans+"" )   ;
              uiwWriter.Status = ""+j+"/"+(ii-1)+" : ET="+ExpTime+"ms x "+NumbScans+" == "+label1+
		                         " < "+label2+" < "+ label3+" "+SpectrumQuality+"" ;

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                            *********************
//***********   Repeat until pressing STOP button or after recording 1000/(3 bad)spectra *********************
//***********                                                                            *********************
//************************************************************************************************************
//***********                                                                                            *****

               while((iLOW<=numberLow) && (iHIGH<=numberHigh) && (ii<=NumberPerSet) && 
			         (!Script.StopAllScripts ))

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

             {

//***********                                                                                            *****
//*********** Scan command ***********************************************************************************
//***********                                                                                            *****

              spectrograph.Scan(MeasSpec,NumbScans,ExpTime)                   ;
              MeasSpec.MinChannel = MinChannelToShow ; MeasSpec.MaxChannel = MaxChannelToShow ;
              MeasSpec.Author = AuthorID ; MeasSpec.Device = specID                           ;
              MeasSpec.Site=locationID ; MeasSpec.Remark=experimentID                         ;
              MeasSpec.UserParam1 = project                                                   ;
			  MeasSpec.UserParam2 = version                                                   ;
			  MeasSpec.UserParam3 = vip20                                                     ;
              Specbar.CurrentSpectrum = MeasSpec ; afnFile.Save(MeasSpec)                     ;
              ii = afnFile.CurrentFileNumber() ; m = ii-1 ; k = Count(m)                      ;
              label2 = parseInt(MeasSpec.Max)                                                 ;
			  Quality()                                                                       ;

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

              time = MeasSpec.StopTime ; maxi = parseInt(MeasSpec.Max+0.5)   ;
              spec = "" + name3 + "_" + k + commonExtension + ""            ;
			  iGLOBAL++ ; ioList.WriteLine(""+iGLOBAL+" "+afnFile.BasePath+afnFile.CurrentSubFolder+spec+"");
              ioCur.WriteLine( ""+(ii-1)+","+spec+","+time+","+LowSignal+","+ maxi+","+
			                   HighSignal+","+SpectrumQuality+","+ExpTime+","+NumbScans+"" )   ;
              uiwWriter.Status = ""+j+"/"+(ii-1)+" : ET="+ExpTime+"ms x "+NumbScans+" == "+label1+" < "+
			                     label2+" < "+ label3+" "+SpectrumQuality+"" ;

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

              }

//***********                                                                                            *****

              ioCur.WriteLine("") ; ioCur.WriteLine(""+project+"") ;
			  ioCur.WriteLine(""+version+"") ; ioCur.WriteLine(""+vip20+"") ;
              ioCur.Close() ;

//***********                                                                                            *****

              stopTIME = Tempo() ; Console.WriteLine(""+stopTIME+"") ;
              ioRes.WriteLine(""+j+","+startTIME+","+ExpTime+","+NumbScans+","+stopTIME+","+ii+"") ;

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

              Console.WriteLine() ; Console.WriteLine("Press STOP to terminate script !") ;
              Console.WriteLine() ; uiwWriter.Status = "Press STOP to terminate script !" ;
              Thread.Sleep(5000)  ; uiwWriter.Status = " "                                ;    

//***********                                                                                            *****

              //                                                                                         *****
           }  // loop until stop button is used                                                          *****
              //                                                                                         *****
           }  // if ( spestro == 0 )                                                                     *****
              //                                                                                         *****
           ioRes.WriteLine("") ; ioRes.WriteLine(""+project+"") ;
		   ioRes.WriteLine(""+version+"") ; ioRes.WriteLine(""+vip20+"") ; 
           ioList.WriteLine("") ; ioList.WriteLine(""+project+"") ;
		   ioList.WriteLine(""+version+"") ; ioList.WriteLine(""+vip20+"") ; 
		   ioRes.Close() ; ioList.Close() ;
		   ioRes = fso.OpenTextFile(TempName , ForReading ) ;
		   ioList = fso.CreateTextFile("c:\\work\\ooi\\"+BasePath+"\\list_"+name1+".txt" , true) ;
		   ioList.WriteLine("" + iGLOBAL + "") ;
           ioList.WriteLine("" + maxIT  + "" ) ;
           ioList.WriteLine("" + maxNAC + "" ) ;
		   ioList.WriteLine("" + locationID + "") ;
		   ioList.WriteLine("" + experimentID + "") ;
		   ioList.WriteLine("" + AuthorID + "") ;
		   for ( i=0 ; i<=iGLOBAL+4 ; i++)
		       { ts = ioRes.ReadLine() ; 
			     ioList.WriteLine(""+ts+"") ; 
			   }
		   ioRes.Close() ;
		   ioRes = fso.GetFile(TempName) ; 
		   ioRes.Delete() ;
		   ioList.Close() ;   		    

		   }  // folder BasePath created - end                                                           *****

//***********                                                                                            *****
//************************************************************************************************************
//***********                                                                                            *****

          Console.WriteLine() ; Console.WriteLine("Protocol file :") ; Console.WriteLine() ;
		  Console.WriteLine("List file : ") ; Console.WriteLine() ;  Console.WriteLine("Ready !") ;
		  Console.WriteLine(); Console.WriteLine(""+project+"") ;  Console.WriteLine(""+version+"") ;
		  Console.WriteLine(""+vip20+"") ;

//***********                                                                                            *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
