//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****  JScript project collection_long.jsp                                                             *****
//*****                                                                                                  *****
//*****  INITIALIZATION                                                                                  *****
//*****                                                                                                  *****
//*****  Version 3.0 / March, 2009                                                                       *****
//*****                                                                                                  *****
//*****  Author V.I. Tsanev (vip20@cam.ac.uk)                                                            *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//*****    NOTE:                                                                                         *****
//*****                                                                                                  *****
//*****            User has to type his inputs only in lines not ending with five starts (*****)         *****
//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
        import  System.Diagnostics ; // interact with system processes, event logs,                      *****
		                             // and performance counters                                         *****
        import  System             ; // use the System libary of the .NET framework                      *****
        import  System.Threading   ; // output console                                                   *****
        import  DoasCore           ; // use the DoasCore library                                         *****
        import  DoasCore.Spectra   ; // use the Spectra namespace                                        *****
        import  DoasCore.IO        ; // use the Input-/Output namespace                                  *****
        import  DoasCore.Device    ; // use the Device namespace                                         *****
        import  DoasCore.Script    ; // use the Script namespace                                         *****
        import  DoasCore.Math      ; // use DoasCore.Math namespace                                      *****
        import  DoasCore.HMI       ; // Doasis Human-Machine-Interface (HMI) extensions                  *****
		                             // (only required if other input/output than the Output window      *****
									 // is needed (Progress Bars, Status Bar))                           *****
//*****                                                                                                  *****
//************************************************************************************************************
//*****                                                                                                  *****
        var dispFileSystem  = new ActiveXObject("Scripting.FileSystemObject") ;  //                      *****
        var uiwWriter : UserInterfaceWriter = new UserInterfaceWriter()       ;  //                      *****
        var spectrograph = new Spectrograph()                                 ;  //                      *****
        var fso = new ActiveXObject("Scripting.FileSystemObject")             ;  //                      *****
//*****                                                                                                  *****
//************************************************************************************************************
//*****                                   ********************************************************************
//***** Input data in the following lines ********************************************************************
//*****                                   ********************************************************************
//************************************************************************************************************
//*****                                                                                                  *****
//***** ( 1) The maximum exposure time for test scans. It has to produce satutated spectrum.             *****
//*****      var MaxExpTime                                                                              *****
//*****                                                                                                  *****

             var MaxExpTime 		    = 900 ;

//*****                                                                                                  *****
//***** ( 2) Desired total integration time in seconds                                                   *****
//*****        = (optimized individual integration time) times (number of co-adds)                       *****
//*****                                                                                                  *****

             var TotalTime = 3 ;

//*****                                                                                                  *****
//***** ( 3) Word used to assembly base folder name, the common protocol name and the names of           *****
//*****      protocols, describing recorded sets of spectra                                              *****
//*****                                                                                                  *****

             var name = "new_long"
        
//*****                                                                                                  *****
//***** ( 4) Exnention of the recorded spectral files (including dot). Recommended is ".std".            *****
//*****                                                                                                  *****

             var commonExtension = ".std"

//*****                                                                                                  *****
//***** ( 5) Spectrometer type. Permitted options are "USB2000", "USB2000+" and "USB4000".               *****
//*****                                                                                                  *****

             var spectrometerTYPE = "USB2000+"

//*****                                                                                                  *****
//***** ( 6) Spectrometer ID (serial number)                                                             *****
//*****                                                                                                  *****

             var specID ="USB2+F00580"

//*****                                                                                                  *****
//***** ( 7) Experiment ID (brief description of the task).                                              *****
//*****                                                                                                  *****

             var experimentID = "home test 4"

//*****                                                                                                  *****
//***** ( 8) Location ID (brief description of experiment location).                                     *****
//*****                                                                                                  *****

             var locationID = "home"

//*****                                                                                                  *****
//***** ( 9) Author ID (e.g. "VIP20" ).                                                                  *****
//*****                                                                                                  *****

            var AuthorID = "vip20"

//*****                                                                                                  *****
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
//************************************************************************************************************
